/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _FIREPAINT_OPTIONS_H
#define _FIREPAINT_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    FirepaintDisplayOptionInitiateKey,
    FirepaintDisplayOptionInitiateButton,
    FirepaintDisplayOptionClearKey,
    FirepaintDisplayOptionClearButton,
    FirepaintDisplayOptionAddParticle,
    FirepaintDisplayOptionNum
} FirepaintDisplayOptions;

typedef void (*firepaintDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, FirepaintDisplayOptions num);

CompOption *firepaintGetDisplayOption (CompDisplay *d, FirepaintDisplayOptions num);

typedef enum
{
    FirepaintScreenOptionNumParticles,
    FirepaintScreenOptionFireSize,
    FirepaintScreenOptionFireSlowdown,
    FirepaintScreenOptionFireLife,
    FirepaintScreenOptionFireColor,
    FirepaintScreenOptionFireMystical,
    FirepaintScreenOptionBgBrightness,
    FirepaintScreenOptionNum
} FirepaintScreenOptions;

typedef void (*firepaintScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, FirepaintScreenOptions num);

CompOption *firepaintGetScreenOption (CompScreen *s, FirepaintScreenOptions num);

CompAction *     firepaintGetInitiateKey (CompDisplay *d);
void             firepaintSetInitiateKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             firepaintSetInitiateKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     firepaintGetInitiateKeyOption (CompDisplay *d);
void             firepaintSetInitiateKeyNotify (CompDisplay *d, firepaintDisplayOptionChangeNotifyProc notify);

CompAction *     firepaintGetInitiateButton (CompDisplay *d);
void             firepaintSetInitiateButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             firepaintSetInitiateButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     firepaintGetInitiateButtonOption (CompDisplay *d);
void             firepaintSetInitiateButtonNotify (CompDisplay *d, firepaintDisplayOptionChangeNotifyProc notify);

CompAction *     firepaintGetClearKey (CompDisplay *d);
void             firepaintSetClearKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             firepaintSetClearKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     firepaintGetClearKeyOption (CompDisplay *d);
void             firepaintSetClearKeyNotify (CompDisplay *d, firepaintDisplayOptionChangeNotifyProc notify);

CompAction *     firepaintGetClearButton (CompDisplay *d);
void             firepaintSetClearButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             firepaintSetClearButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     firepaintGetClearButtonOption (CompDisplay *d);
void             firepaintSetClearButtonNotify (CompDisplay *d, firepaintDisplayOptionChangeNotifyProc notify);

CompAction *     firepaintGetAddParticle (CompDisplay *d);
void             firepaintSetAddParticleInitiate (CompDisplay *d, CompActionCallBackProc init);
void             firepaintSetAddParticleTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     firepaintGetAddParticleOption (CompDisplay *d);
void             firepaintSetAddParticleNotify (CompDisplay *d, firepaintDisplayOptionChangeNotifyProc notify);

int              firepaintGetNumParticles (CompScreen *s);
CompOption *     firepaintGetNumParticlesOption (CompScreen *s);
void             firepaintSetNumParticlesNotify (CompScreen *s, firepaintScreenOptionChangeNotifyProc notify);

float            firepaintGetFireSize (CompScreen *s);
CompOption *     firepaintGetFireSizeOption (CompScreen *s);
void             firepaintSetFireSizeNotify (CompScreen *s, firepaintScreenOptionChangeNotifyProc notify);

float            firepaintGetFireSlowdown (CompScreen *s);
CompOption *     firepaintGetFireSlowdownOption (CompScreen *s);
void             firepaintSetFireSlowdownNotify (CompScreen *s, firepaintScreenOptionChangeNotifyProc notify);

float            firepaintGetFireLife (CompScreen *s);
CompOption *     firepaintGetFireLifeOption (CompScreen *s);
void             firepaintSetFireLifeNotify (CompScreen *s, firepaintScreenOptionChangeNotifyProc notify);

unsigned short * firepaintGetFireColor (CompScreen *s);
unsigned short   firepaintGetFireColorRed (CompScreen *s);
unsigned short   firepaintGetFireColorGreen (CompScreen *s);
unsigned short   firepaintGetFireColorBlue (CompScreen *s);
unsigned short   firepaintGetFireColorAlpha (CompScreen *s);
CompOption *     firepaintGetFireColorOption (CompScreen *s);
void             firepaintSetFireColorNotify (CompScreen *s, firepaintScreenOptionChangeNotifyProc notify);

Bool             firepaintGetFireMystical (CompScreen *s);
CompOption *     firepaintGetFireMysticalOption (CompScreen *s);
void             firepaintSetFireMysticalNotify (CompScreen *s, firepaintScreenOptionChangeNotifyProc notify);

int              firepaintGetBgBrightness (CompScreen *s);
CompOption *     firepaintGetBgBrightnessOption (CompScreen *s);
void             firepaintSetBgBrightnessNotify (CompScreen *s, firepaintScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
