/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _GRID_OPTIONS_H
#define _GRID_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    GridDisplayOptionPutCenterKey,
    GridDisplayOptionPutLeftKey,
    GridDisplayOptionPutRightKey,
    GridDisplayOptionPutTopKey,
    GridDisplayOptionPutBottomKey,
    GridDisplayOptionPutTopleftKey,
    GridDisplayOptionPutToprightKey,
    GridDisplayOptionPutBottomleftKey,
    GridDisplayOptionPutBottomrightKey,
    GridDisplayOptionNum
} GridDisplayOptions;

typedef void (*gridDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, GridDisplayOptions num);

CompOption *gridGetDisplayOption (CompDisplay *d, GridDisplayOptions num);

typedef enum
{
    GridScreenOptionNum
} GridScreenOptions;

typedef void (*gridScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, GridScreenOptions num);

CompOption *gridGetScreenOption (CompScreen *s, GridScreenOptions num);

CompAction *     gridGetPutCenterKey (CompDisplay *d);
void             gridSetPutCenterKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             gridSetPutCenterKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     gridGetPutCenterKeyOption (CompDisplay *d);
void             gridSetPutCenterKeyNotify (CompDisplay *d, gridDisplayOptionChangeNotifyProc notify);

CompAction *     gridGetPutLeftKey (CompDisplay *d);
void             gridSetPutLeftKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             gridSetPutLeftKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     gridGetPutLeftKeyOption (CompDisplay *d);
void             gridSetPutLeftKeyNotify (CompDisplay *d, gridDisplayOptionChangeNotifyProc notify);

CompAction *     gridGetPutRightKey (CompDisplay *d);
void             gridSetPutRightKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             gridSetPutRightKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     gridGetPutRightKeyOption (CompDisplay *d);
void             gridSetPutRightKeyNotify (CompDisplay *d, gridDisplayOptionChangeNotifyProc notify);

CompAction *     gridGetPutTopKey (CompDisplay *d);
void             gridSetPutTopKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             gridSetPutTopKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     gridGetPutTopKeyOption (CompDisplay *d);
void             gridSetPutTopKeyNotify (CompDisplay *d, gridDisplayOptionChangeNotifyProc notify);

CompAction *     gridGetPutBottomKey (CompDisplay *d);
void             gridSetPutBottomKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             gridSetPutBottomKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     gridGetPutBottomKeyOption (CompDisplay *d);
void             gridSetPutBottomKeyNotify (CompDisplay *d, gridDisplayOptionChangeNotifyProc notify);

CompAction *     gridGetPutTopleftKey (CompDisplay *d);
void             gridSetPutTopleftKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             gridSetPutTopleftKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     gridGetPutTopleftKeyOption (CompDisplay *d);
void             gridSetPutTopleftKeyNotify (CompDisplay *d, gridDisplayOptionChangeNotifyProc notify);

CompAction *     gridGetPutToprightKey (CompDisplay *d);
void             gridSetPutToprightKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             gridSetPutToprightKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     gridGetPutToprightKeyOption (CompDisplay *d);
void             gridSetPutToprightKeyNotify (CompDisplay *d, gridDisplayOptionChangeNotifyProc notify);

CompAction *     gridGetPutBottomleftKey (CompDisplay *d);
void             gridSetPutBottomleftKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             gridSetPutBottomleftKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     gridGetPutBottomleftKeyOption (CompDisplay *d);
void             gridSetPutBottomleftKeyNotify (CompDisplay *d, gridDisplayOptionChangeNotifyProc notify);

CompAction *     gridGetPutBottomrightKey (CompDisplay *d);
void             gridSetPutBottomrightKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             gridSetPutBottomrightKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     gridGetPutBottomrightKeyOption (CompDisplay *d);
void             gridSetPutBottomrightKeyNotify (CompDisplay *d, gridDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
