/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _GROUP_OPTIONS_H
#define _GROUP_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    GroupDisplayOptionSelectButton,
    GroupDisplayOptionSelectSingleKey,
    GroupDisplayOptionGroupKey,
    GroupDisplayOptionUngroupKey,
    GroupDisplayOptionRemoveKey,
    GroupDisplayOptionCloseKey,
    GroupDisplayOptionIgnoreKey,
    GroupDisplayOptionTabmodeKey,
    GroupDisplayOptionChangeTabLeftKey,
    GroupDisplayOptionChangeTabRightKey,
    GroupDisplayOptionChangeColorKey,
    GroupDisplayOptionNum
} GroupDisplayOptions;

typedef void (*groupDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, GroupDisplayOptions num);

CompOption *groupGetDisplayOption (CompDisplay *d, GroupDisplayOptions num);

typedef enum
{
    GroupScreenOptionMoveAll,
    GroupScreenOptionResizeAll,
    GroupScreenOptionRaiseAll,
    GroupScreenOptionMaximizeUnmaximizeAll,
    GroupScreenOptionMinimizeAll,
    GroupScreenOptionShadeAll,
    GroupScreenOptionAutoGroup,
    GroupScreenOptionAutoUngroup,
    GroupScreenOptionWindowMatch,
    GroupScreenOptionSelectOpacity,
    GroupScreenOptionSelectSaturation,
    GroupScreenOptionSelectBrightness,
    GroupScreenOptionSelectPrecision,
    GroupScreenOptionFillColor,
    GroupScreenOptionLineColor,
    GroupScreenOptionMipmaps,
    GroupScreenOptionUntabOnClose,
    GroupScreenOptionAutotabCreate,
    GroupScreenOptionTabbarShowDelay,
    GroupScreenOptionTabbingSpeed,
    GroupScreenOptionTabbingTimestep,
    GroupScreenOptionFadeTime,
    GroupScreenOptionPulseTime,
    GroupScreenOptionReflexTime,
    GroupScreenOptionFadeTextTime,
    GroupScreenOptionVisibilityTime,
    GroupScreenOptionChangeAnimationTime,
    GroupScreenOptionBarAnimations,
    GroupScreenOptionThumbSize,
    GroupScreenOptionThumbSpace,
    GroupScreenOptionBorderRadius,
    GroupScreenOptionBorderWidth,
    GroupScreenOptionTabBaseColor,
    GroupScreenOptionTabBorderColor,
    GroupScreenOptionTabHighlightColor,
    GroupScreenOptionTabStyle,
    GroupScreenOptionTabbarFontFamily,
    GroupScreenOptionTabbarFontSize,
    GroupScreenOptionTabbarFontColor,
    GroupScreenOptionDndUngroupWindow,
    GroupScreenOptionDragHoverTime,
    GroupScreenOptionDragSpringK,
    GroupScreenOptionDragFriction,
    GroupScreenOptionDragYDistance,
    GroupScreenOptionDragSpeedLimit,
    GroupScreenOptionGlow,
    GroupScreenOptionGlowSize,
    GroupScreenOptionGlowType,
    GroupScreenOptionNum
} GroupScreenOptions;

typedef void (*groupScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, GroupScreenOptions num);

CompOption *groupGetScreenOption (CompScreen *s, GroupScreenOptions num);

typedef enum
{
    TabStyleSimple = 0,
    TabStyleGradient = 1,
    TabStyleGlass = 2,
    TabStyleMetal = 3,
    TabStyleMurrina = 4,
} GroupTabStyleEnum;

typedef enum
{
    GlowTypeRectangularGlow = 0,
    GlowTypeGlowRing = 1,
} GroupGlowTypeEnum;

CompAction *     groupGetSelectButton (CompDisplay *d);
void             groupSetSelectButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetSelectButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetSelectButtonOption (CompDisplay *d);
void             groupSetSelectButtonNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetSelectSingleKey (CompDisplay *d);
void             groupSetSelectSingleKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetSelectSingleKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetSelectSingleKeyOption (CompDisplay *d);
void             groupSetSelectSingleKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetGroupKey (CompDisplay *d);
void             groupSetGroupKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetGroupKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetGroupKeyOption (CompDisplay *d);
void             groupSetGroupKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetUngroupKey (CompDisplay *d);
void             groupSetUngroupKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetUngroupKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetUngroupKeyOption (CompDisplay *d);
void             groupSetUngroupKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetRemoveKey (CompDisplay *d);
void             groupSetRemoveKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetRemoveKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetRemoveKeyOption (CompDisplay *d);
void             groupSetRemoveKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetCloseKey (CompDisplay *d);
void             groupSetCloseKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetCloseKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetCloseKeyOption (CompDisplay *d);
void             groupSetCloseKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetIgnoreKey (CompDisplay *d);
void             groupSetIgnoreKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetIgnoreKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetIgnoreKeyOption (CompDisplay *d);
void             groupSetIgnoreKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetTabmodeKey (CompDisplay *d);
void             groupSetTabmodeKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetTabmodeKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetTabmodeKeyOption (CompDisplay *d);
void             groupSetTabmodeKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetChangeTabLeftKey (CompDisplay *d);
void             groupSetChangeTabLeftKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetChangeTabLeftKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetChangeTabLeftKeyOption (CompDisplay *d);
void             groupSetChangeTabLeftKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetChangeTabRightKey (CompDisplay *d);
void             groupSetChangeTabRightKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetChangeTabRightKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetChangeTabRightKeyOption (CompDisplay *d);
void             groupSetChangeTabRightKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

CompAction *     groupGetChangeColorKey (CompDisplay *d);
void             groupSetChangeColorKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             groupSetChangeColorKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     groupGetChangeColorKeyOption (CompDisplay *d);
void             groupSetChangeColorKeyNotify (CompDisplay *d, groupDisplayOptionChangeNotifyProc notify);

Bool             groupGetMoveAll (CompScreen *s);
CompOption *     groupGetMoveAllOption (CompScreen *s);
void             groupSetMoveAllNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetResizeAll (CompScreen *s);
CompOption *     groupGetResizeAllOption (CompScreen *s);
void             groupSetResizeAllNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetRaiseAll (CompScreen *s);
CompOption *     groupGetRaiseAllOption (CompScreen *s);
void             groupSetRaiseAllNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetMaximizeUnmaximizeAll (CompScreen *s);
CompOption *     groupGetMaximizeUnmaximizeAllOption (CompScreen *s);
void             groupSetMaximizeUnmaximizeAllNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetMinimizeAll (CompScreen *s);
CompOption *     groupGetMinimizeAllOption (CompScreen *s);
void             groupSetMinimizeAllNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetShadeAll (CompScreen *s);
CompOption *     groupGetShadeAllOption (CompScreen *s);
void             groupSetShadeAllNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetAutoGroup (CompScreen *s);
CompOption *     groupGetAutoGroupOption (CompScreen *s);
void             groupSetAutoGroupNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetAutoUngroup (CompScreen *s);
CompOption *     groupGetAutoUngroupOption (CompScreen *s);
void             groupSetAutoUngroupNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

CompMatch *      groupGetWindowMatch (CompScreen *s);
CompOption *     groupGetWindowMatchOption (CompScreen *s);
void             groupSetWindowMatchNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetSelectOpacity (CompScreen *s);
CompOption *     groupGetSelectOpacityOption (CompScreen *s);
void             groupSetSelectOpacityNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetSelectSaturation (CompScreen *s);
CompOption *     groupGetSelectSaturationOption (CompScreen *s);
void             groupSetSelectSaturationNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetSelectBrightness (CompScreen *s);
CompOption *     groupGetSelectBrightnessOption (CompScreen *s);
void             groupSetSelectBrightnessNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetSelectPrecision (CompScreen *s);
CompOption *     groupGetSelectPrecisionOption (CompScreen *s);
void             groupSetSelectPrecisionNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

unsigned short * groupGetFillColor (CompScreen *s);
unsigned short   groupGetFillColorRed (CompScreen *s);
unsigned short   groupGetFillColorGreen (CompScreen *s);
unsigned short   groupGetFillColorBlue (CompScreen *s);
unsigned short   groupGetFillColorAlpha (CompScreen *s);
CompOption *     groupGetFillColorOption (CompScreen *s);
void             groupSetFillColorNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

unsigned short * groupGetLineColor (CompScreen *s);
unsigned short   groupGetLineColorRed (CompScreen *s);
unsigned short   groupGetLineColorGreen (CompScreen *s);
unsigned short   groupGetLineColorBlue (CompScreen *s);
unsigned short   groupGetLineColorAlpha (CompScreen *s);
CompOption *     groupGetLineColorOption (CompScreen *s);
void             groupSetLineColorNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetMipmaps (CompScreen *s);
CompOption *     groupGetMipmapsOption (CompScreen *s);
void             groupSetMipmapsNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetUntabOnClose (CompScreen *s);
CompOption *     groupGetUntabOnCloseOption (CompScreen *s);
void             groupSetUntabOnCloseNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetAutotabCreate (CompScreen *s);
CompOption *     groupGetAutotabCreateOption (CompScreen *s);
void             groupSetAutotabCreateNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetTabbarShowDelay (CompScreen *s);
CompOption *     groupGetTabbarShowDelayOption (CompScreen *s);
void             groupSetTabbarShowDelayNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetTabbingSpeed (CompScreen *s);
CompOption *     groupGetTabbingSpeedOption (CompScreen *s);
void             groupSetTabbingSpeedNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetTabbingTimestep (CompScreen *s);
CompOption *     groupGetTabbingTimestepOption (CompScreen *s);
void             groupSetTabbingTimestepNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetFadeTime (CompScreen *s);
CompOption *     groupGetFadeTimeOption (CompScreen *s);
void             groupSetFadeTimeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetPulseTime (CompScreen *s);
CompOption *     groupGetPulseTimeOption (CompScreen *s);
void             groupSetPulseTimeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetReflexTime (CompScreen *s);
CompOption *     groupGetReflexTimeOption (CompScreen *s);
void             groupSetReflexTimeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetFadeTextTime (CompScreen *s);
CompOption *     groupGetFadeTextTimeOption (CompScreen *s);
void             groupSetFadeTextTimeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetVisibilityTime (CompScreen *s);
CompOption *     groupGetVisibilityTimeOption (CompScreen *s);
void             groupSetVisibilityTimeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetChangeAnimationTime (CompScreen *s);
CompOption *     groupGetChangeAnimationTimeOption (CompScreen *s);
void             groupSetChangeAnimationTimeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetBarAnimations (CompScreen *s);
CompOption *     groupGetBarAnimationsOption (CompScreen *s);
void             groupSetBarAnimationsNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetThumbSize (CompScreen *s);
CompOption *     groupGetThumbSizeOption (CompScreen *s);
void             groupSetThumbSizeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetThumbSpace (CompScreen *s);
CompOption *     groupGetThumbSpaceOption (CompScreen *s);
void             groupSetThumbSpaceNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetBorderRadius (CompScreen *s);
CompOption *     groupGetBorderRadiusOption (CompScreen *s);
void             groupSetBorderRadiusNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetBorderWidth (CompScreen *s);
CompOption *     groupGetBorderWidthOption (CompScreen *s);
void             groupSetBorderWidthNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

unsigned short * groupGetTabBaseColor (CompScreen *s);
unsigned short   groupGetTabBaseColorRed (CompScreen *s);
unsigned short   groupGetTabBaseColorGreen (CompScreen *s);
unsigned short   groupGetTabBaseColorBlue (CompScreen *s);
unsigned short   groupGetTabBaseColorAlpha (CompScreen *s);
CompOption *     groupGetTabBaseColorOption (CompScreen *s);
void             groupSetTabBaseColorNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

unsigned short * groupGetTabBorderColor (CompScreen *s);
unsigned short   groupGetTabBorderColorRed (CompScreen *s);
unsigned short   groupGetTabBorderColorGreen (CompScreen *s);
unsigned short   groupGetTabBorderColorBlue (CompScreen *s);
unsigned short   groupGetTabBorderColorAlpha (CompScreen *s);
CompOption *     groupGetTabBorderColorOption (CompScreen *s);
void             groupSetTabBorderColorNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

unsigned short * groupGetTabHighlightColor (CompScreen *s);
unsigned short   groupGetTabHighlightColorRed (CompScreen *s);
unsigned short   groupGetTabHighlightColorGreen (CompScreen *s);
unsigned short   groupGetTabHighlightColorBlue (CompScreen *s);
unsigned short   groupGetTabHighlightColorAlpha (CompScreen *s);
CompOption *     groupGetTabHighlightColorOption (CompScreen *s);
void             groupSetTabHighlightColorNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetTabStyle (CompScreen *s);
CompOption *     groupGetTabStyleOption (CompScreen *s);
void             groupSetTabStyleNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

char *           groupGetTabbarFontFamily (CompScreen *s);
CompOption *     groupGetTabbarFontFamilyOption (CompScreen *s);
void             groupSetTabbarFontFamilyNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetTabbarFontSize (CompScreen *s);
CompOption *     groupGetTabbarFontSizeOption (CompScreen *s);
void             groupSetTabbarFontSizeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

unsigned short * groupGetTabbarFontColor (CompScreen *s);
unsigned short   groupGetTabbarFontColorRed (CompScreen *s);
unsigned short   groupGetTabbarFontColorGreen (CompScreen *s);
unsigned short   groupGetTabbarFontColorBlue (CompScreen *s);
unsigned short   groupGetTabbarFontColorAlpha (CompScreen *s);
CompOption *     groupGetTabbarFontColorOption (CompScreen *s);
void             groupSetTabbarFontColorNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetDndUngroupWindow (CompScreen *s);
CompOption *     groupGetDndUngroupWindowOption (CompScreen *s);
void             groupSetDndUngroupWindowNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetDragHoverTime (CompScreen *s);
CompOption *     groupGetDragHoverTimeOption (CompScreen *s);
void             groupSetDragHoverTimeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetDragSpringK (CompScreen *s);
CompOption *     groupGetDragSpringKOption (CompScreen *s);
void             groupSetDragSpringKNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

float            groupGetDragFriction (CompScreen *s);
CompOption *     groupGetDragFrictionOption (CompScreen *s);
void             groupSetDragFrictionNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetDragYDistance (CompScreen *s);
CompOption *     groupGetDragYDistanceOption (CompScreen *s);
void             groupSetDragYDistanceNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetDragSpeedLimit (CompScreen *s);
CompOption *     groupGetDragSpeedLimitOption (CompScreen *s);
void             groupSetDragSpeedLimitNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

Bool             groupGetGlow (CompScreen *s);
CompOption *     groupGetGlowOption (CompScreen *s);
void             groupSetGlowNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetGlowSize (CompScreen *s);
CompOption *     groupGetGlowSizeOption (CompScreen *s);
void             groupSetGlowSizeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

int              groupGetGlowType (CompScreen *s);
CompOption *     groupGetGlowTypeOption (CompScreen *s);
void             groupSetGlowTypeNotify (CompScreen *s, groupScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
