/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SHOWMOUSE_OPTIONS_H
#define _SHOWMOUSE_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    ShowmouseDisplayOptionInitiate,
    ShowmouseDisplayOptionInitiateButton,
    ShowmouseDisplayOptionInitiateEdge,
    ShowmouseDisplayOptionNum
} ShowmouseDisplayOptions;

typedef void (*showmouseDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, ShowmouseDisplayOptions num);

CompOption *showmouseGetDisplayOption (CompDisplay *d, ShowmouseDisplayOptions num);

typedef enum
{
    ShowmouseScreenOptionNumParticles,
    ShowmouseScreenOptionSize,
    ShowmouseScreenOptionSlowdown,
    ShowmouseScreenOptionLife,
    ShowmouseScreenOptionDarken,
    ShowmouseScreenOptionBlend,
    ShowmouseScreenOptionColor,
    ShowmouseScreenOptionRandom,
    ShowmouseScreenOptionRotationSpeed,
    ShowmouseScreenOptionRadius,
    ShowmouseScreenOptionEmiters,
    ShowmouseScreenOptionNum
} ShowmouseScreenOptions;

typedef void (*showmouseScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, ShowmouseScreenOptions num);

CompOption *showmouseGetScreenOption (CompScreen *s, ShowmouseScreenOptions num);

CompAction *     showmouseGetInitiate (CompDisplay *d);
void             showmouseSetInitiateInitiate (CompDisplay *d, CompActionCallBackProc init);
void             showmouseSetInitiateTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     showmouseGetInitiateOption (CompDisplay *d);
void             showmouseSetInitiateNotify (CompDisplay *d, showmouseDisplayOptionChangeNotifyProc notify);

CompAction *     showmouseGetInitiateButton (CompDisplay *d);
void             showmouseSetInitiateButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             showmouseSetInitiateButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     showmouseGetInitiateButtonOption (CompDisplay *d);
void             showmouseSetInitiateButtonNotify (CompDisplay *d, showmouseDisplayOptionChangeNotifyProc notify);

CompAction *     showmouseGetInitiateEdge (CompDisplay *d);
void             showmouseSetInitiateEdgeInitiate (CompDisplay *d, CompActionCallBackProc init);
void             showmouseSetInitiateEdgeTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     showmouseGetInitiateEdgeOption (CompDisplay *d);
void             showmouseSetInitiateEdgeNotify (CompDisplay *d, showmouseDisplayOptionChangeNotifyProc notify);

int              showmouseGetNumParticles (CompScreen *s);
CompOption *     showmouseGetNumParticlesOption (CompScreen *s);
void             showmouseSetNumParticlesNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

float            showmouseGetSize (CompScreen *s);
CompOption *     showmouseGetSizeOption (CompScreen *s);
void             showmouseSetSizeNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

float            showmouseGetSlowdown (CompScreen *s);
CompOption *     showmouseGetSlowdownOption (CompScreen *s);
void             showmouseSetSlowdownNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

float            showmouseGetLife (CompScreen *s);
CompOption *     showmouseGetLifeOption (CompScreen *s);
void             showmouseSetLifeNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

float            showmouseGetDarken (CompScreen *s);
CompOption *     showmouseGetDarkenOption (CompScreen *s);
void             showmouseSetDarkenNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

Bool             showmouseGetBlend (CompScreen *s);
CompOption *     showmouseGetBlendOption (CompScreen *s);
void             showmouseSetBlendNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

unsigned short * showmouseGetColor (CompScreen *s);
unsigned short   showmouseGetColorRed (CompScreen *s);
unsigned short   showmouseGetColorGreen (CompScreen *s);
unsigned short   showmouseGetColorBlue (CompScreen *s);
unsigned short   showmouseGetColorAlpha (CompScreen *s);
CompOption *     showmouseGetColorOption (CompScreen *s);
void             showmouseSetColorNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

Bool             showmouseGetRandom (CompScreen *s);
CompOption *     showmouseGetRandomOption (CompScreen *s);
void             showmouseSetRandomNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

float            showmouseGetRotationSpeed (CompScreen *s);
CompOption *     showmouseGetRotationSpeedOption (CompScreen *s);
void             showmouseSetRotationSpeedNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

int              showmouseGetRadius (CompScreen *s);
CompOption *     showmouseGetRadiusOption (CompScreen *s);
void             showmouseSetRadiusNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

int              showmouseGetEmiters (CompScreen *s);
CompOption *     showmouseGetEmitersOption (CompScreen *s);
void             showmouseSetEmitersNotify (CompScreen *s, showmouseScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
