/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WALLPAPER_OPTIONS_H
#define _WALLPAPER_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    WallpaperDisplayOptionNum
} WallpaperDisplayOptions;

typedef void (*wallpaperDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, WallpaperDisplayOptions num);

CompOption *wallpaperGetDisplayOption (CompDisplay *d, WallpaperDisplayOptions num);

typedef enum
{
    WallpaperScreenOptionBgImage,
    WallpaperScreenOptionBgImagePos,
    WallpaperScreenOptionBgFillType,
    WallpaperScreenOptionBgColor1,
    WallpaperScreenOptionBgColor2,
    WallpaperScreenOptionNum
} WallpaperScreenOptions;

typedef void (*wallpaperScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, WallpaperScreenOptions num);

CompOption *wallpaperGetScreenOption (CompScreen *s, WallpaperScreenOptions num);

typedef enum
{
    BgImagePosScaleAndCrop = 0,
    BgImagePosScaled = 1,
    BgImagePosCentered = 2,
    BgImagePosTiled = 3,
    BgImagePosCenterTiled = 4,
} WallpaperBgImagePosEnum;

typedef enum
{
    BgFillTypeSolidFill = 0,
    BgFillTypeVerticalGradient = 1,
    BgFillTypeHorizontalGradient = 2,
} WallpaperBgFillTypeEnum;

#define BgImagePosScaleAndCropMask (1 << 0)
#define BgImagePosScaledMask (1 << 1)
#define BgImagePosCenteredMask (1 << 2)
#define BgImagePosTiledMask (1 << 3)
#define BgImagePosCenterTiledMask (1 << 4)


#define BgFillTypeSolidFillMask (1 << 0)
#define BgFillTypeVerticalGradientMask (1 << 1)
#define BgFillTypeHorizontalGradientMask (1 << 2)


CompListValue *  wallpaperGetBgImage (CompScreen *s);
CompOption *     wallpaperGetBgImageOption (CompScreen *s);
void             wallpaperSetBgImageNotify (CompScreen *s, wallpaperScreenOptionChangeNotifyProc notify);

CompListValue *  wallpaperGetBgImagePos (CompScreen *s);
unsigned int     wallpaperGetBgImagePosMask (CompScreen *s);
CompOption *     wallpaperGetBgImagePosOption (CompScreen *s);
void             wallpaperSetBgImagePosNotify (CompScreen *s, wallpaperScreenOptionChangeNotifyProc notify);

CompListValue *  wallpaperGetBgFillType (CompScreen *s);
unsigned int     wallpaperGetBgFillTypeMask (CompScreen *s);
CompOption *     wallpaperGetBgFillTypeOption (CompScreen *s);
void             wallpaperSetBgFillTypeNotify (CompScreen *s, wallpaperScreenOptionChangeNotifyProc notify);

CompListValue *  wallpaperGetBgColor1 (CompScreen *s);
CompOption *     wallpaperGetBgColor1Option (CompScreen *s);
void             wallpaperSetBgColor1Notify (CompScreen *s, wallpaperScreenOptionChangeNotifyProc notify);

CompListValue *  wallpaperGetBgColor2 (CompScreen *s);
CompOption *     wallpaperGetBgColor2Option (CompScreen *s);
void             wallpaperSetBgColor2Notify (CompScreen *s, wallpaperScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
